import classNames from "classnames";
import React from "react";
import Empty from "xy-empty";
import "xy-empty/assets/index.css";
/**
 * Select下拉列表
 *   - 处理下拉列表滚动条，和对应ref转发
 *   - 展示空内容占位符
 */
export function Dropdown(props) {
    var _a = props.prefixCls, prefixCls = _a === void 0 ? "xy-select" : _a, className = props.className, style = props.style, children = props.children, placeholder = props.placeholder, empty = props.empty, scrollwrapRef = props.scrollwrapRef;
    var dropdownPrefixCls = prefixCls + "-dropdown";
    var classString = classNames(dropdownPrefixCls, className);
    return (React.createElement("div", { className: classString, style: style },
        React.createElement("div", { className: dropdownPrefixCls + "__scrollwrap", ref: scrollwrapRef },
            React.createElement("ul", { role: "listbox", className: dropdownPrefixCls + "__menu" },
                React.createElement("div", { style: { display: empty || !children || React.Children.count(children) === 0 ? "none" : null } }, children),
                (empty || (!children || React.Children.count(children) === 0)) && React.createElement(Empty, { description: placeholder })))));
}
export default React.memo(Dropdown);
//# sourceMappingURL=index.js.map